## Installation

*Rookeries* is heavily under development and once things stabilize there will be a user friendly installation guide.
In the meantime, please refer to the development guide below.

## Development

*Rookeries* uses the following technologies:

- Rust 1.27+
- NodeJS 10 + ES6
- CouchDB 2.x
- Docker + docker-compose
- Make

### Getting Started

**Rookeries** requires newer versions of Docker (<1.9.0) and docker-compose (<1.8.0).

1. [Install docker-compose](https://docs.docker.com/compose/install/)
1. Build Rookeries: `make build`
1. Run tests: `make test`
1. Run demo: `make demo`
1. Run the invoke scripts on a running Rookeries container with: `docker-compose exec rookeries inv $MY_TASK`
    - Use `inv -l` to list the available invoke tasks.
1. Run the npm scripts on a running Rookeries container with: `docker-compose exec rookeries npm run $MY_TASK`
1. When running the demo, navigate to the main Rookeries page in a browser: [http://localhost:5000/](http://localhost:5000/)
